	xdef	_main
	xdef	_comment

	xdef	_ti92plus
	xdef	_ti89

	include "tios.h"
	include "genlib.h"
	include "flib.h"

	include "Macros.h"

_main:
	jsr	genlib::init		; Init GenLib
	jsr	genlib::set_LCD_MEM	; To see the LCD_MEM after genlib's init.
	jsr	flib::zap_screen	; Clear LCD_SCREEN
	WriteStr	#1,#1,#4,sync_str
	jsr	genlib::synchronize	; Synchro ...
	jsr	flib::zap_screen
	tst.w	d0
	beq.s	\ok
	WriteStr	#1,#1,#4,bad_str
	bra	fin
\ok:	WriteStr	#1,#1,#4,ok_str
	lea	genlib::link_data,a0
	cmp.w	#MASTER,link_flag(a0)
	beq.s	\mas
	WriteStr #1,#10,#4,slave_str
	bra.s	\fin2
\mas:
	WriteStr #1,#10,#4,master_str
\fin2:	jsr	genlib::wait_no_key
	jsr	genlib::wait_a_key

; allocate a new dscreen
	genlib::PUSH_DSCREEN	d0
	move.l	d0,Screen
; Set it
	jsr	genlib::set_dscreen_int
	jsr	genlib::set_dscreen_function
	jsr	genlib::cls
; Set sprite plane
	clr.w	genlib::sprite_scr_x
	clr.w	genlib::sprite_scr_y
	move.l	#tile,genlib::sprite_tile_adr

; Coordinate of the current ship
	moveq	#100,d4
	moveq	#110,d5
; init link
	lea	buffer_r(PC),a1
	lea	buffer_s(PC),a2
	clr.l	(a1)
	clr.l	(a2)
	clr.l	coor_2
	moveq	#2,d1
	moveq	#2,d2
	jsr	genlib::set_link

	clr.l	genlib::timer
loop:
	jsr	genlib::read_joypad
	move.l	d0,keys
	btst.b	#up_key,d0
	bne.s	\no_up
	subq.w	#1,d5
\no_up:
	btst.b	#down_key,d0
	bne.s	\no_down
	addq.w	#1,d5
\no_down:
	btst.b	#left_key,d0
	bne.s	\no_left
	subq.w	#1,d4
\no_left:
	btst.b	#right_key,d0
	bne.s	\no_right
	addq.w	#1,d4
\no_right:

; Receive & send new data ?
; If you separate them, you can have some strange bugs if your program
; go faster than the auto-link-int :
; One calc : always in sending mode ; the other : always in receiving mode !
; because "reception >> send"
	lea	genlib::link_data,a0
	cmp.b	#DONE,buffer_recpt_flag(a0)
	bne.s	\no_new
	cmp.b	#DONE,buffer_send_flag(a0)
	bne.s	\no_new
	move.b	#IN_PROGRESS,buffer_recpt_flag(a0)	; I want a new receive buffer !
	move.b	#IN_PROGRESS,buffer_send_flag(a0)
	move.w	buffer_r(PC),coor_2	; copy buffer to avoid a destruction
	move.b	d4,buffer_s		; Create a new buffer
	move.b	d5,buffer_s+1
	jsr	genlib::send_data	; Send it (not really)
\no_new

; Wait next 15Hz
\wait:	cmp.l	#5,genlib::timer
	bls.s	\wait			; 15 Hz waiting
	subq.l	#6,genlib::timer

	jsr	genlib::cls
; Print
	move.w	d4,d0
	move.w	d5,d1
	moveq	#0,d2
	lea	genlib::link_data,a0
	move.w	link_flag(a0),d2
	jsr	genlib::put_sprite_16

	moveq	#0,d0
	move.b	coor_2(PC),d0
	moveq	#0,d1
	move.b	coor_2+1(PC),d1
	moveq	#0,d2
	lea	genlib::link_data,a0
	move.w	link_flag(a0),d2
	eor.w	#1,d2
	jsr	genlib::put_sprite_16

	move.l	keys(PC),d0
	btst.b	#exit_key,d0
	bne	loop
\quitter:	

	genlib::POP_DSCREEN
fin:	jsr	genlib::quit		; Quit GenLib
	rts

keys	dc.l	0
Screen	dc.l	0

buffer_r	dc.w	0
buffer_s	dc.w	0
coor_2		dc.w	0

tile:
	incbin "fernand.bin"
sync_str:
	dc.b "Synch ?",0
ok_str:
	dc.b "Ok",0
bad_str:
	dc.b "bad",0
master_str:
	dc.b "MASTER !!!!!",0
slave_str:
	dc.b "slave.......",0
_comment:
	dc.b "Example : Link",0

	end
