#include <doors.h>
#include <all.h>

#include "gen.h"

int _ti89,_ti92plus; // compile for both calcs

SPRITE_16	Sprite =
	{
	{1045, 1195},
	{1045, 1195},
	{1045, 1195},
	{1045, 1195},
	{1045, 1195},
	{1045, 1195},
	{1045, 1195},
	{1045, 1195},
	{1045, 1195},
	{1045, 1195},
	{1045, 1195},
	{1045, 1195},
	{1045, 1195},
	{1045, 1195},
	{1045, 1195},
	{1045, 1195},
	};

DSCREEN	*Scr1;
DSCREEN	*Scr2;

// Wait for the timer and do double-buffer
void	wait(void)
{
	static char tps = 0;
	if (tps)
		{
		gl_set_dscreen_int(Scr1);
		gl_set_dscreen_function(Scr2);
		}
	else
		{
		gl_set_dscreen_int(Scr2);
		gl_set_dscreen_function(Scr1);
		}
	tps = !tps;
	while (gl_timer < 3);
	gl_timer = 0;
}

void	movexy(short *x, short *y, JOYPAD j)
{
 if (j.up_key == 0) (*y)--;
 if (j.down_key == 0) (*y)++;
 if (j.left_key == 0) (*x)--;
 if (j.right_key == 0) (*x)++;
}

void _main(void)
{
	volatile HANDLE	Hd;
	POINT P = {0,0}, C = {100,50};
	JOYPAD j;
	char	*ptr;
	short	i;

	// Init genlib
	gl_init();

	// Alloc two DScreens
	gl_init_dscreen(&Scr1, &Hd);
	if (Hd == H_NULL) return;
	gl_push_hd(Hd);

	gl_init_dscreen(&Scr2, &Hd);
	if (Hd == H_NULL){
		gl_free_hd();
		return;
		}
	gl_push_hd(Hd);

	// Init DScreens
	gl_set_dscreen_int(Scr1);
	gl_set_dscreen_function(Scr1);

	// Clear the current DScreen
	gl_cls();

	// Init sprite_16
	gl_set_spr_xy(0,0);
	gl_set_spr_tile(Sprite);

	// Put sprite...
	do
	{
	gl_cls();
	movexy( &(P.x), &(P.y), j = gl_read_joypad());
	gl_put_sprite_16(P.x, P.y, 0);
	wait();
	} while (j.exit_key);

	gl_wait_no_key();

	gl_cls();
	gl_put_large_string(LCD_MEM, 32, 43, "Pixel demo...");
	gl_copy_window();
	wait();
	gl_cls();

	// Put some pixels
	for(P.x = 0 ; P.x < 240 ; P.x++)
		for( P.y = 0 ; P.y < 128 ; P.y++)
			{
			i = P.x + P.y;
			gl_put_pixel(&P, i);
			}
	wait();
	gl_wait_a_key();

	// Put some circles
	gl_cls();
	for(i = 0 ; i < 100 ; i+=10)
		gl_draw_clipped_circle(&C, i, i);
	wait();
	gl_wait_a_key();

	gl_free_hd();
	gl_quit();
}

